Package com.xebialabs.deployit.plugin.api.udm.base

## Class BaseDeployableArtifact

- java.lang.Object
- - com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem
  - - com.xebialabs.deployit.plugin.api.udm.base.BaseDeployable
    - - com.xebialabs.deployit.plugin.api.udm.base.BaseDeployableArtifact

- All Implemented Interfaces:
    `Artifact`, `SourceArtifact`, `ConfigurationItem`, `Deployable`, `DeployableArtifact`, `Taggable`, `java.io.Serializable`, `java.lang.Comparable<BaseConfigurationItem>`
  Direct Known Subclasses:
    `BaseDeployableFileArtifact`, `BaseDeployableFolderArtifact`

      @Metadata(virtual=true,
                description="The supertype of all DeployableArtifacts.")
      public class BaseDeployableArtifact
      extends BaseDeployable
      implements DeployableArtifact

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `SCAN_PLACEHOLDERS_PROPERTY_NAME` |

    - ### Fields inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

      `id, syntheticProperties, type`

    - ### Fields inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

      `SYNTHETIC_PROPERTIES_FIELD, TYPE_FIELD`

    - ### Fields inherited from interface com.xebialabs.deployit.plugin.api.udm.artifact.SourceArtifact

      `CHECKSUM_PROPERTY_NAME, FILE_URI_PROPERTY_NAME, IS_RESCANNED_PROPERTY_NAME`

    - ### Fields inherited from interface com.xebialabs.deployit.plugin.api.udm.Taggable

      `TAGS_FIELD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BaseDeployableArtifact()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getChecksum()` | Returns the (calculated or user-defined) checksum of the artifact file.
    `com.xebialabs.deployit.plugin.credentials.Credentials` | `getCredentials()` | Returns the credentials for artifact location.
    `java.lang.String` | `getDelimiters()` |
    `java.lang.String` | `getExcludeFileNamesRegex()` |
    `com.xebialabs.overthere.OverthereFile` | `getFile()` |
    `java.util.Map<java.lang.String,​java.lang.String>` | `getFileEncodings()` | This will return a map that specifies which files map to which encodings.
    `java.lang.String` | `getFileUri()` | Returns the artifact location which can be resolved using an artifact resolver.
    `java.util.Set<java.lang.String>` | `getPlaceholders()` |
    `com.xebialabs.deployit.plugin.proxy.ProxySettings` | `getProxySettings()` | Returns the proxy settings for artifact location.
    `boolean` | `getRescanned()` |
    `java.lang.String` | `getTextFileNamesRegex()` |
    `boolean` | `isPreScannedPlaceholders()` |
    `boolean` | `isScanPlaceholders()` |
    `void` | `setChecksum​(java.lang.String checksum)` |
    `void` | `setCredentials​(com.xebialabs.deployit.plugin.credentials.Credentials credentials)` |
    `void` | `setDelimiters​(java.lang.String delimiters)` |
    `void` | `setExcludeFileNamesRegex​(java.lang.String excludeFileNamesRegex)` |
    `void` | `setFile​(com.xebialabs.overthere.OverthereFile file)` |
    `void` | `setPlaceholders​(java.util.Set<java.lang.String> placeholders)` |
    `void` | `setPreScannedPlaceholders​(boolean preScannedPlaceholders)` |
    `void` | `setProxySettings​(com.xebialabs.deployit.plugin.proxy.ProxySettings proxySettings)` |
    `void` | `setRescanned​(boolean rescanned)` |
    `void` | `setScanPlaceholders​(boolean scanPlaceholders)` |
    `void` | `setTextFileNamesRegex​(java.lang.String textFileNamesRegex)` |

    - ### Methods inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseDeployable

      `getBoundTemplates, getTags, setBoundTemplates, setTags`

    - ### Methods inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

      `compareTo, equals, get$ciAttributes, get$directoryReference, get$externalProperties, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$token, get$validationMessages, getId, getName, getProperty, getPropertyDescriptor, getType, hashCode, hasProperty, set$ciAttributes, set$directoryReference, set$externalProperties, set$internalId, set$referenceId, set$securedCi, set$securedDirectoryReference, set$token, set$validationMessages, setId, setProperty, setType, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

      `get$directoryReference, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$validationMessages, getId, getName, getProperty, getType, hasProperty, setId, setProperty`

    - ### Methods inherited from interface com.xebialabs.deployit.plugin.api.udm.Taggable

      `getTags, setTags`

- - ### Field Detail

    - #### SCAN_PLACEHOLDERS_PROPERTY_NAME

          public static final java.lang.String SCAN_PLACEHOLDERS_PROPERTY_NAME

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### BaseDeployableArtifact

          public BaseDeployableArtifact()

  - ### Method Detail

    - #### getCredentials

          public com.xebialabs.deployit.plugin.credentials.Credentials getCredentials()

      Description copied from interface: `SourceArtifact`
      Returns the credentials for artifact location.
      Specified by:
        `getCredentials` in interface `SourceArtifact`

    - #### setCredentials

          public void setCredentials​(com.xebialabs.deployit.plugin.credentials.Credentials credentials)

    - #### getProxySettings

          public com.xebialabs.deployit.plugin.proxy.ProxySettings getProxySettings()

      Description copied from interface: `SourceArtifact`
      Returns the proxy settings for artifact location.
      Specified by:
        `getProxySettings` in interface `SourceArtifact`

    - #### setProxySettings

          public void setProxySettings​(com.xebialabs.deployit.plugin.proxy.ProxySettings proxySettings)

    - #### getFile

          public com.xebialabs.overthere.OverthereFile getFile()

      Specified by:
        `getFile` in interface `Artifact`
      Returns:
        A representation of a file that can be access through an Overthere connection.

    - #### setFile

          public void setFile​(com.xebialabs.overthere.OverthereFile file)

      Specified by:
        `setFile` in interface `Artifact`
      Parameters:
        `file` - A representation of a file that can be access through an Overthere connection.

    - #### isScanPlaceholders

          public boolean isScanPlaceholders()

    - #### setScanPlaceholders

          public void setScanPlaceholders​(boolean scanPlaceholders)

    - #### isPreScannedPlaceholders

          public boolean isPreScannedPlaceholders()

    - #### setPreScannedPlaceholders

          public void setPreScannedPlaceholders​(boolean preScannedPlaceholders)

    - #### getPlaceholders

          public java.util.Set<java.lang.String> getPlaceholders()

      Specified by:
        `getPlaceholders` in interface `SourceArtifact`

    - #### setPlaceholders

          public void setPlaceholders​(java.util.Set<java.lang.String> placeholders)

      Specified by:
        `setPlaceholders` in interface `SourceArtifact`

    - #### getTextFileNamesRegex

          public java.lang.String getTextFileNamesRegex()

      Specified by:
        `getTextFileNamesRegex` in interface `SourceArtifact`

    - #### setTextFileNamesRegex

          public void setTextFileNamesRegex​(java.lang.String textFileNamesRegex)

    - #### getExcludeFileNamesRegex

          public java.lang.String getExcludeFileNamesRegex()

      Specified by:
        `getExcludeFileNamesRegex` in interface `SourceArtifact`
      Returns:
        regex that captures all the files that should not be scanned.

    - #### getFileEncodings

          public java.util.Map<java.lang.String,​java.lang.String> getFileEncodings()

      Description copied from interface: `SourceArtifact`
      This will return a map that specifies which files map to which encodings. By default XL Deploy will use UTF-8 for replacing placeholders in files, unless this property contains a regex as key which matches the path of the file within the artifact. If a key matches, XL Deploy will use the attached value in the map as encoding for replacing placeholders in the file.
      Specified by:
        `getFileEncodings` in interface `SourceArtifact`
      Returns:
        map that maps a regex to a target encoding for a file.

    - #### getFileUri

          public java.lang.String getFileUri()

      Description copied from interface: `SourceArtifact`
      Returns the artifact location which can be resolved using an artifact resolver.
      Specified by:
        `getFileUri` in interface `SourceArtifact`

    - #### setExcludeFileNamesRegex

          public void setExcludeFileNamesRegex​(java.lang.String excludeFileNamesRegex)

    - #### getChecksum

          public java.lang.String getChecksum()

      Description copied from interface: `SourceArtifact`
      Returns the (calculated or user-defined) checksum of the artifact file.
      Specified by:
        `getChecksum` in interface `SourceArtifact`

    - #### setChecksum

          public void setChecksum​(java.lang.String checksum)

    - #### getDelimiters

          public java.lang.String getDelimiters()

    - #### setDelimiters

          public void setDelimiters​(java.lang.String delimiters)

    - #### getRescanned

          public boolean getRescanned()

    - #### setRescanned

          public void setRescanned​(boolean rescanned)